import { Component, ChangeDetectionStrategy, Inject, PLATFORM_ID, ElementRef, HostBinding, Input, NgModule } from '@angular/core';
import { isPlatformBrowser, CommonModule } from '@angular/common';
import { HighlightJsService, HighlightJsModule } from 'angular2-highlight-js';
import * as _marked from 'marked';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/code-snippet/code-snippet.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const marked = _marked;
class CodeSnippetComponent {
    /**
     * @param {?} platformId
     * @param {?} el
     * @param {?} highlightJsService
     */
    constructor(platformId, el, highlightJsService) {
        this.platformId = platformId;
        this.el = el;
        this.highlightJsService = highlightJsService;
        this.setClass = true;
        this.processMarkdown = false;
        this.scrollable = true;
    }
    /**
     * @return {?}
     */
    ngOnChanges() {
        if (this.processMarkdown) {
            this.codeSnippet = marked(this.codeSnippet);
        }
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        if (isPlatformBrowser(this.platformId)) {
            /** @type {?} */
            const allPreEl = this.el.nativeElement.querySelectorAll('pre');
            for (const preElement of allPreEl) {
                if (!preElement.classList.contains('a-pre')) {
                    preElement.className += ' a-pre';
                    if (this.scrollable) {
                        preElement.className += ' a-pre--scrollable';
                    }
                }
                this.highlightJsService.highlight(preElement);
            }
        }
    }
}
CodeSnippetComponent.decorators = [
    { type: Component, args: [{
                selector: 'aui-code-snippet',
                template: "<div class=\"aui-code-snippet__inner\">\n  <pre *ngIf=\"!this.processMarkdown\"><code>{{ codeSnippet }}</code></pre>\n\n  <div *ngIf=\"this.processMarkdown\" [innerHTML]=\"codeSnippet\" class=\"code-snippet-md\"></div>\n</div>\n",
                changeDetection: ChangeDetectionStrategy.OnPush
            }] }
];
/** @nocollapse */
CodeSnippetComponent.ctorParameters = () => [
    { type: undefined, decorators: [{ type: Inject, args: [PLATFORM_ID,] }] },
    { type: ElementRef },
    { type: HighlightJsService }
];
CodeSnippetComponent.propDecorators = {
    setClass: [{ type: HostBinding, args: ['class.ngx-code-snippet',] }],
    codeSnippet: [{ type: Input }],
    processMarkdown: [{ type: Input }],
    scrollable: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    CodeSnippetComponent.prototype.setClass;
    /** @type {?} */
    CodeSnippetComponent.prototype.codeSnippet;
    /** @type {?} */
    CodeSnippetComponent.prototype.processMarkdown;
    /** @type {?} */
    CodeSnippetComponent.prototype.scrollable;
    /**
     * @type {?}
     * @private
     */
    CodeSnippetComponent.prototype.platformId;
    /**
     * @type {?}
     * @private
     */
    CodeSnippetComponent.prototype.el;
    /**
     * @type {?}
     * @private
     */
    CodeSnippetComponent.prototype.highlightJsService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/code-snippet.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class CodeSnippetModule {
}
CodeSnippetModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    HighlightJsModule,
                ],
                declarations: [
                    CodeSnippetComponent,
                ],
                providers: [
                    HighlightJsService,
                ],
                exports: [
                    CodeSnippetComponent,
                ],
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: acpaas-ui-ngx-code-snippet.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { CodeSnippetComponent, CodeSnippetModule };
//# sourceMappingURL=acpaas-ui-ngx-code-snippet.js.map
